
unit main;

{-$DEFINE MAKE_LOG}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls,
  
  FlashViewers;

(* http://www.delphiflash.com/delphi-swf-sdk-download *)

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    FlashViewer1: TFlashViewer;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FlashViewer1Click(Sender: TObject);
    procedure FlashViewer1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Timer1Timer(Sender: TObject);
  private
    { Dclarations prives }
    fX: integer;
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  global;

procedure AddToFile(const aFilename: string; const aText: string);
var
  f: TextFile;
begin
  AssignFile(f, aFileName);
{$I-}
  Append(f);
{$I+}
  if IOResult <> 0 then
    Rewrite(f);
  Write(f, aText);
  CloseFile(f);
end;

{$J+}
const
  log: string = 'log.txt';

procedure TForm1.FormShow(Sender: TObject);
var
  i: Integer;
begin
  ShowWindow(Application.Handle, SW_HIDE);
  SystemParametersInfo(SPI_SCREENSAVERRUNNING, 1, @i, 0);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  i: Integer;
begin
  SystemParametersInfo(SPI_SCREENSAVERRUNNING, 0, @i, 0);
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  FlashViewer1.SetBounds(0, 0, ClientWidth, ClientHeight)
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  fX := -1;
  ReadIni;
  if Pos('\', SWF_FileName) = 0 then
    SWF_FileName := ExtractFilePath(ParamStr(0)) + SWF_FileName;

  log := ExtractFilePath(ParamStr(0)) + log;

{$IFDEF MAKE_LOG}
  AddToFile(log, SWF_FileName + #13#10);
{$ENDIF}

  FlashViewer1.Align := alNone;
  FlashViewer1.Movie := SWF_FileName;
end;

procedure TForm1.FlashViewer1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.FlashViewer1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  if fX = -1 then
    fX := X
  else
    if fX <> X then
      Close;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  s: TKeyboardState;
  i: integer;
begin
  GetKeyboardState(s);
  for i := 0 to 255 do
    if (s[i] and 128) = 128 then
      Close;
end;

end.
